var validation = new Array();

/* Note that the months are zero based in JS while days and years aren't! Confusing. */

function createDateMDY(value) {
	if(/^\d\d\/\d\d\/[12]\d\d\d$/.test(value) && !/Invalid|NaN/.test(new Date(value.slice(3,5) - 1, value.slice(6,10), value.slice(0,2)))) {
		return new Date(value.slice(3,5) - 1, value.slice(6,10), value.slice(0,2));
	}
	else {
		return '';
	}
}

function createDateDMY(value) {
	if(/^\d\d\/\d\d\/[12]\d\d\d$/.test(value) && !/Invalid|NaN/.test(new Date(value.slice(6,10), value.slice(3,5) - 1, value.slice(0,2)))) {
		return new Date(value.slice(6,10), value.slice(3,5) - 1, value.slice(0,2));
	}
	else {
		return '';
	}
}

/* Handy function to evaluate multiple elements for validation
	(validation.element() only takes one at a time) */
function v_element(selector) {
	if(validation[$(selector.form).attr("id")] && validation[$(selector.form).attr("id")].element) {
		$(selector).each(function() {
			validation[$(selector.form).attr("id")].element(this);
		});
	};
}

function IsEmail(email) {
	return email.match(/^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/);
}
function popup(url) {window.open(url,"windowname","toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=500,top=0,left=0");}


/*
 * Image preview script 
 * powered by jQuery (http://www.jquery.com)
 * 
 * written by Alen Grakalic (http:/cssglobe.com)
 * 
 * for more info visit http:/cssglobe.com/post/1695/easiest-tooltip-and-image-preview-using-jquery
 *
 */
 
this.imagePreview = function(){	
	/* CONFIG */
		
		xOffset = 10;
		yOffset = 30;
		
		// these 2 variable determine popup's distance from the cursor
		// you might want to adjust to get the right result
		
	/* END CONFIG */
	$("a.preview").hover(function(e){
		this.t = this.title;
		this.title = "";	
		var c = (this.t != "") ? "<br/>" + this.t : "";
		$("body").append('<p id="preview"><img src="'+ this.href +'" alt="Image preview" />'+ c +'</p>');								 
		$("#preview")
			.css("top",(e.pageY - xOffset) + "px")
			.css("left",(e.pageX + yOffset) + "px")
			.fadeIn("fast");						
    },
	function(){
		if(this.t) this.title = this.t;	
		$("#preview").remove();
    });	
	$("a.preview").mousemove(function(e){
		$("#preview")
			.css("top",(e.pageY - xOffset) + "px")
			.css("left",(e.pageX + yOffset) + "px");
	});			
};


if($) {

	$().ready(function() {

		imagePreview();

		/* Anti-multiple-submitting code */
		/* "form[action] is because we only want to add the protection to forms that have an action attribute specified */
		/* 		ie, not including simple forms that are just a select box with a JS redirect, etc. */
/*		$("form[action]").submit(function() {
		if (typeof $(this).attr("submitcount") != 'undefined' && $(this).attr("submitcount") > 0) {
				return false;
			}
			else {
				$(this).attr("submitcount", "1");
			};
		});
		$("form[action] *:input").change(function() {
			$(this.form).removeAttr("submitcount");
		}); */

		if($.validator) {

			$.validator.setDefaults({ 
				errorClass: "v_invalid",
				errorPlacement: function(error, element) {
					element.parents(".v_container").eq(0).append(error);
				}
			});

			/* By default, select boxes aren't validated until they've lost focus.
				We want them validated onchange. */
			$("form[action] select").change(function() {
				if(validation[$(this.form).attr("id")] && validation[$(this.form).attr("id")].settings.rules[$(this).attr("name")]) {
					validation[$(this.form).attr("id")].element(this);
				};
			});
			/* Make sure all inputs are validated on blur (by default this only happens after the user has tried to
				submit the form for the first time). */
			$("form[action] *:input").blur(function() {
				if(validation[$(this.form).attr("id")] && validation[$(this.form).attr("id")].settings.rules[$(this).attr("name")]) {
					validation[$(this.form).attr("id")].element(this);
				};
			});
			/* ...in the case of checkboxes, onclick */
			$("form[action] *:checkbox").click(function() {
				if(validation[$(this.form).attr("id")] && validation[$(this.form).attr("id")].settings.rules[$(this).attr("name")]) {
					validation[$(this.form).attr("id")].element(this);
				};
			});

			/* Custom validation functions for jQuery validation plugin */
			$.validator.addMethod(
				"dateDMY",
				function(value) {
					return !(value) || createDateDMY(value).toString().length; //return true if no value is entered for validation, if the value is required, default validation will be used
				},
				"Please enter a date in the format dd/mm/yyyy."
			);
			$.validator.addMethod(
				"dateMDY",
				function(value) {
					return !(value) || createDateMDY(value).toString().length;
				},
				"Please enter a date in the format mm/dd/yyyy."
			);
			$.validator.addMethod(
				"dateInFutureDMY",
				function(value) {
					var testDate = createDateDMY(value);
					return !(value) || testDate.toString().length && testDate.getTime() >= new Date().getTime();
				},
				"Please enter a future date in the format dd/mm/yyyy."
			);
			$.validator.addMethod(
				"dateInFutureMDY",
				function(value) {
					var testDate = createDateMDY(value);
					return !(value) || testDate.toString().length && testDate.getTime() >= new Date().getTime();
				},
				"Please enter a future date in the format mm/dd/yyyy."
			);
			$.validator.addMethod(
				"dateInPastDMY",
				function(value) {
					var testDate = createDateDMY(value);
					return !(value) || testDate.toString().length && testDate.getTime() <= new Date().getTime();
				},
				"Please enter a past date in the format dd/mm/yyyy."
			);
			$.validator.addMethod(
				"dateInPastMDY",
				function(value) {
					var testDate = createDateMDY(value);
					return !(value) || testDate.toString().length && testDate.getTime() <= new Date().getTime();
				},
				"Please enter a past date in the format mm/dd/yyyy."
			);
			
			$.validator.addMethod(
				"multiemail", 
				function(value) { 
					//Allow multiple addresses separated by comma
					return !(value) || /^([a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4},?)+$/.test(value);
				}, 
				"One or more email addresses are invalid"
			);

			$.validator.addMethod(
				"stringContainsLocatorGroupID", 
				function(value) { 
					//String should contain LocatorGroupID=
					return !(value) || /LocatorGroupID=[0-9]+/.test(value);
				}, 
				'Source Search String should contains "LocatorGroupID=(LocatorGroupID value)".'
			);

		};

		if($.fn && $.fn.media) {
			$.fn.media.defaults.canUndo = false;
			$.fn.media.defaults.flvPlayer = '/scripts/jquery/mediaplayer.swf';
			$.fn.media.defaults.mp3Player = '/scripts/jquery/mediaplayer.swf';
			$.fn.media.defaults.bgColor = 'transparent';
			$.fn.media.mapFormat('mp3','quicktime');
			$('.j_drawmedia').media();
		};

		/* Make lightbox click up in groups based on rel attribute. If rel is just "lightbox", that image pops up by itself. */

		$("a[rel=lightbox]").each(function(){$(this).lightBox()});
		
		/* Otherwise, multiple rels like lightbox[groupname] will pop up as a group (ie you can go back and next between them). */		
		//17-08-2011 ca: this is moved to common.js  
		var UsedRelGroups = new Array();
		
		/* Loop through each and collect rels of all rels with groups - the selector here is any anchor with a rel that 
		   starts with lightbox, but does not equal lightbox. For each of these, add a value to an array 
		  (Note that the array here is more of a structure - the value is not important - we just want to access the keys.)
		   Once we have the array we can loop through it and apply lightbox to each anchor */
		
		$("a[rel^=lightbox][rel!=lightbox]").each(function(){UsedRelGroups[$(this).attr("rel")] = 0;});
		
		for(key in UsedRelGroups) {
			/* Apply lightbox to each group. */
			$("a[rel='" + key + "']").lightBox();
		};
		

		if ($.fn.fancybox) {
			$("a.fancybox:not(.disabled)").each(function() {
				
				/* use data attributes of the anchor tags to change different settings 
				   for example:
				   - data-fancybox-type="iframe" to change to 'iframe'

				   additional options can be added: check http://fancybox.net/api

				   give the same rel value (on the anchor tags) to combine images into gallery
				*/

				var options = {};

				var padding = $(this).data("fancyboxPadding");
				var margin = $(this).data("fancyboxMargin");
				var scrolling = $(this).data("fancyboxScrolling");
				var height = $(this).data("fancyboxHeight");
				var width = $(this).data("fancyboxWidth");
				var href = $(this).data("fancyboxHref");
				var type = $(this).data("fancyboxType"); 
				
				if (typeof padding !== 'undefined' && $.isNumeric(padding)) { options.padding = padding; }
				if (typeof margin !== 'undefined' && $.isNumeric(margin)) { options.margin = margin; }
				if (typeof scrolling !== 'undefined' && scrolling.length) { options.scrolling = scrolling; }
				if (typeof height !== 'undefined' && $.isNumeric(height)) { options.height = height; }
				if (typeof width !== 'undefined' && $.isNumeric(width)) { options.width = width; }
				if (typeof href !== 'undefined' && href.length) { options.href = href; }
				if (typeof type !== 'undefined' && type.length) { options.type = type; }

				$(this).fancybox(options);
			});
		}
		
		/* Some sites have a link which you can click to view large images. This has the class viewlargerimages
		   When it is clicked, it is effectively the same as clicking on the group identified by the attribute 
		   lightbox[productimages] */
		
		$("#viewlargerimages").click(function() {
			$("a[rel='lightbox[productimages]']").each(function() {
				// "eq(0)" returns the corresponding HTML object itself.
				$(this).eq(0).click();
				return false;
			});
			return false;
		});
		
		// The first selector here is finding the link around the image
		$("a[rel*=lightbox]").each(function() { // For every lightbox pic, find its caption and make the caption open the pic
			var ThisPicLink = this;
			// The selector here is for finding a link within the first SPAN following the image link. This SPAN contains the image caption.
			$(this).next("span").children("a[rel*=lightcaption]").click(function() {
				$(ThisPicLink).click();
				return false;
			});
		});

		 $("input.j_dateselect").datepicker({
				changeMonth: true, 
				changeYear: true,
				dateFormat: "dd/mm/yy",
				yearRange: "-10:+10",
				onSelect: function() {
					$(this).change().blur(); // Important for triggering jquery form validation on change
				}
		 });
		 
		 $("input.j_dateselectfuture").datepicker({
				changeMonth: true, 
				changeYear: true,
				dateFormat: "dd/mm/yy",	
				minDate: +0,
				yearRange: "nn:+10",
				onSelect: function() {
					$(this).change().blur(); // Important for triggering jquery form validation on change
				}
		 });
		 
		 $("input.j_dateselectpast").datepicker({
				changeMonth: true, 
				changeYear: true,
				dateFormat: "dd/mm/yy",
				maxDate: 0,
				yearRange: "-10:nn",
				onSelect: function() {
					$(this).change().blur(); // Important for triggering jquery form validation on change
				}
		 });		 
		 
		 $("input.j_dateselect[name=DateOfBirth],input.j_dateselect[birthday=Yes]").datepicker(
				"option", "yearRange", "1920:2020"
		 );		 
		 
		 $(".ui-datepicker-calendar a").live("click",function(event){ event.preventDefault(); }); // to stop it returning you to top of page

		// onrollover button for form submit image buttons - toggle "-over" to the filename
		$("input[type='image'][src*='uploads/'],img[imageover*='uploads/']").each(function() {
			var overUrl = $(this).attr("imageover");
			var sourceUrl = $(this).attr("src");
			if(overUrl) {
				//preload the image over
				$("#preload").append('<img src="' + overUrl + '" width="1" height="1" alt="Preloaded image"/>');
				//register hover event
				$(this).hover(
					function() {															 
						$(this).attr("src", overUrl);
					}, 
					function() {
						$(this).attr("src", sourceUrl);
				});
			}
		});
		
		
	});

};

// IE does not know about Array.indexOf so we make it available to IE by the following code:

if (typeof Array.indexOf !== 'function') {
	Array.prototype.indexOf = function(o) {
		for (var i=0; i<this.length; i++) {
			if (this[i] === o) {
				return i;
			}
		}
		return -1;
	}
};

// jQuery custom function to prevent multiple submissions
// also taking into account form validation
jQuery.fn.preventDoubleSubmission = function(errorMessage) {

  var thisFormObj = $(this); 
  
  if (typeof errorMessage == 'undefined') {
	errorMessage = 'Your request is currently being processed.';  
  }
  
  $(this).bind('submit', { formObj: thisFormObj }, function(e){
	
	if ($(this).data('submitted') === true) {
	  // Previously submitted - don't submit again
	  e.preventDefault();
	  alert(errorMessage);
	  
	} else {
	  
	  if (thisFormObj.valid()) {
		  // Mark this so that the next submit can be ignored
		  $(this).data('submitted', true);
	  } 
	}
  });

  // Keep chainability
  return $(this);
};


function makeAlternateRegExp(arr) {
	finalString = "";
	if(typeof arr != "undefined" && arr.length) {
		for(var i = 0; i < arr.length; i++){
			if(typeof arr[i] != "undefined" && arr[i].length) finalString+=arr[i].replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&")+"|";
		};
		finalString=finalString.replace(/\|+/g, "|");
		finalString=finalString.replace(/^\|+|\|+$/g, "");
	};
	if(finalString.length) {
		return "("+finalString+")";
	}
	else {
		return "";
	};
}

function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

function CreateURI(arrDocPath, arrAttributes) {
	var TheURL = "/";
	TheURL += arrDocPath.join("/");
	TheURL += "/?";
	TheURL = TheURL.replace(/\/+/g, "/");
	TheURL += arrAttributes.join("&");
	TheURL = TheURL.replace(/&+/g, "&");
	return TheURL;
}

/* use regular expressions to determine credit card type based on the number */
function creditCardTypeFromNumber(num) {
	// first, sanitize the number by removing all non-digit characters.
	num = num.replace(/[^\d]/g,'');
	// now test the number against some regexes to figure out the card type.
	if (num.match(/^5[1-5]\d{14}$/)) {
		return 'Mastercard';
	} else if (num.match(/^4\d{15}/) || num.match(/^4\d{12}/)) {
		return 'Visa';
	} else if (num.match(/^3[47]\d{13}/)) {
		return 'AmEx';
	} else if (num.match(/^6011\d{12}/)) {
		return 'Discover';
	}
	return 'UNKNOWN';
}	